package sw.programme.rfid.uhf.permission;


import android.annotation.SuppressLint;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.pm.PackageManager;
import android.os.Build;

import java.util.ArrayList;
import java.util.List;

import sw.programme.rfid.uhf.demo.R;


/**
 * Created by miller.pan on 2017/10/6.
 */

public class AppPermissionHelper {
    private static final int REQUEST_CODE_ASK_PERMISSIONS = 999;

    @SuppressLint("InlinedApi")
    public static boolean allowPermission(Activity activity) {
        if (activity == null)
            return false;

        if (PermissionHelper.shouldAskPermission() == false)
            return true;

        boolean bWriteFilePermission = PermissionHelper.checkSelfPermission(activity, android.Manifest.permission.WRITE_EXTERNAL_STORAGE);
        boolean bReadFilePermission = PermissionHelper.checkSelfPermission(activity, android.Manifest.permission.READ_EXTERNAL_STORAGE);

        List<String> permissionsList = new ArrayList<String>();
        if (bWriteFilePermission == false) {
            permissionsList.add(android.Manifest.permission.WRITE_EXTERNAL_STORAGE);
        }

        if (bReadFilePermission == false) {
            permissionsList.add(android.Manifest.permission.READ_EXTERNAL_STORAGE);
        }

        int size = permissionsList.size();
        if (size <= 0) {
            return true;
        }

        PermissionHelper.requestPermissions(activity, permissionsList, AppPermissionHelper.REQUEST_CODE_ASK_PERMISSIONS);
        return false;
    }

    public static boolean onRequestPermissionsResult(Activity activity, int requestCode, String[] permissions, int[] grantResults) {
        if (activity == null)
            return false;

        if (Build.VERSION.SDK_INT < Build.VERSION_CODES.M)
            return true;

        if (requestCode == AppPermissionHelper.REQUEST_CODE_ASK_PERMISSIONS) {
            if (grantResults[0] == PackageManager.PERMISSION_GRANTED) {
                activity.finish();
                activity.startActivity(activity.getIntent());
                return true;
            }

            String title = activity.getString(R.string.app_name);
            String msg = activity.getString(R.string.STR_PermissionsAllow);

            AlertDialog.Builder builder = new AlertDialog.Builder(activity);
            builder.setTitle(title);
            builder.setMessage(msg);

            builder.setPositiveButton(activity.getResources().getString(android.R.string.ok), new DialogInterface.OnClickListener() {
                @Override
                public void onClick(DialogInterface var1, int var2) {
                    System.exit(1);
                }
            });

            builder.show();
        } else {
            activity.onRequestPermissionsResult(requestCode, permissions, grantResults);
        }

        return false;
    }
}
